import org.junit.Rule;
import org.junit.Test;
import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.lang.reflect.Method;

import static org.junit.Assert.assertEquals;

public class Aufgabe2Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Rule
    public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    @Test
    public void test() throws Exception {
        Method create = Aufgabe2.class.getDeclaredMethod("createArray", int.class);
        assertEquals(true, create.getReturnType().equals(double[].class));
        create.setAccessible(true);
        Method print = Aufgabe2.class.getDeclaredMethod("printArray", double[].class, int.class);
        print.setAccessible(true);
        Method halve = Aufgabe2.class.getDeclaredMethod("halveArray", double[].class);
        halve.setAccessible(true);
        double[] a = (double[])create.invoke(null, 0);
        double[] b = (double[])create.invoke(null, 1);
        double[] c = (double[])create.invoke(null, 100);
        double[] d = (double[])create.invoke(null, 1000);
        assertEquals(0, a.length);
        assertEquals(1, b.length);
        assertEquals(100, c.length);
        assertEquals(1000, d.length);
        assertEquals(true, sumup(c) > 0.0);
        assertEquals(true, sumup(d) > 0.0);
        assertEquals(true, rangecheck(b));
        assertEquals(true, rangecheck(c));
        assertEquals(true, rangecheck(d));

        System.out.println();
        System.out.println("Test-Output zu Aufgabe2:");

        String[] testValues = new String[]{
                "",
                "Test-Output zu Aufgabe2:",
                "0",
                "0",
                "15",
                "5",
                "2",
                "4",
                "2",
                "2",
                "4",
                "1",
                "1",
                "1",
                "2",
                "2",
                "1",
                "1",
                "1",
                "1",
                "6",
                "5",
                "2",
                "2",
                "0",
                "0",
                "0"
        };
        StringBuilder testString = new StringBuilder();
        for(String i: testValues) {
            testString.append(i).append(System.lineSeparator());
        }

        b = new double[]{1.0, 33.4, 12.3, 44.5, 89.2, 44.3, 99.9, 3.0, 0.0, 5.8, 22.9, 66.6, 77.7, 54.3, 55.5};
        print.invoke(null, a, 2);
        print.invoke(null, b, 1);
        print.invoke(null, b, 5);
        print.invoke(null, b, 10);
        halve.invoke(null, b);
        print.invoke(null, b, 7);

        assertEquals(testString.toString(), log.getLog());
    }

    private static double sumup(double[] array) {
        double sum = 0;
        for (double v : array) {
            sum += v;
        }
        return sum;
    }

    private static boolean rangecheck(double[] array) {
        for (double v : array) {
            if (v < 0.0 || v >= 100.0) {
                return false;
            }
        }
        return true;
    }
}
