import org.junit.Rule;
import org.junit.Test;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.lang.reflect.Method;

import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertEquals;

public class Aufgabe3Test {

    @Rule
    public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Test
    public void testOutput() throws Exception {
        Method fill = Aufgabe3.class.getDeclaredMethod("fillArray", new Class[]{int[][].class});
        assertEquals(true, fill.getReturnType().equals(Integer.TYPE));
        fill.setAccessible(true);

        Method print = Aufgabe3.class.getDeclaredMethod("printArray", new Class[]{int[][].class});
        assertEquals(true, fill.getReturnType().equals(Integer.TYPE));
        print.setAccessible(true);

        Method trans = Aufgabe3.class.getDeclaredMethod("transpose", new Class[]{int[][].class});
        trans.setAccessible(true);

        System.out.println();
        System.out.println("Test-Output zu Aufgabe3:");

        String[] testValues = new String[]{
                "",
                "Test-Output zu Aufgabe3:",
                "10",
                "0,1,2,3,",
                "4,5,6,",
                "7,8,",
                "9,",
                "4",
                "0,4,7,9,",
                "1,5,8,",
                "2,6,",
                "3,",
                "1",
                "0,",
                "1",
                "0,",
                "8",
                "0,1,2,3,",
                "",
                "4,5,6,",
                "7,",
                "4"
        };
        StringBuilder testString = new StringBuilder();
        for(String i: testValues) {
            testString.append(i).append(System.lineSeparator());
        }

        int[][] a = {{0, 0, 0, 0}, {0, 0, 0}, {0, 0}, {0} };
        System.out.println(fill.invoke(null, new Object[]{a}));
        System.out.println(print.invoke(null, new Object[]{a}));
        trans.invoke(null, new Object[]{a});
        print.invoke(null, new Object[]{a});
        a = new int[][]{ {0} };
        System.out.println(fill.invoke(null, new Object[]{a}));
        System.out.println(print.invoke(null, new Object[]{a}));
        trans.invoke(null, new Object[]{a});
        print.invoke(null, new Object[]{a});
        a = new int[][]{ {0, 0, 0, 0}, {}, {0, 0, 0}, {0} };
        System.out.println(fill.invoke(null, new Object[]{a}));
        System.out.println(print.invoke(null, new Object[]{a}));

        assertEquals(testString.toString(), log.getLog());
    }

}