/*
    Aufgabe4) Rekursion und Termination

    Die Methoden f, g, h, p und q sind vorgegeben. Rufen Sie in main jede dieser Methoden mit allen Argumenten im
    Bereich von [-10, 10] (in aufsteigender Reihenfolge) auf und geben sie die Ergebnisse aus, wenn die Aufrufe mit
    diesen Argumenten terminieren. Aufrufe, die nicht terminieren würden, sind auszulassen. Vermeiden Sie Exceptions.

    Hinweis: Für diese Aufgabe ist es besonders wichtig, die Zusatzfragen beantworten zu können.

    Zusatzfragen:
    1. Nennen Sie für jeden nicht terminierenden Aufruf von f, g, h, p und q im Intervall -10, 10] einen Grund für die
       Endlosrekursion (im Hinblick auf Fundiertheit und Fortschritt).
    2. Beschreiben Sie überblicksartig, was die Methoden f, g, h, p und q berechnen.
    3. Bedeutet ein StackOverflowError immer, dass eine Endlosrekursion vorhanden ist?
    4. [optional] Ist die Aufgabe überhaupt lösbar (wegen der Unentscheidbarkeit des Halteproblems der Turing-Maschine)?
*/
public class Aufgabe4 {

    private static int f(int x) {
        return x * x > 10 ? 0 : f(x - 1) + 1;
    }

    private static int g(int x) {
        return x < 0 ? 0 : g(x / 2) + 1;
    }

    private static int h(int x) {
        return x > 10 ? 0 : h(x * x) + 1;
    }

    private static int p(int x) {
        return x == 0 ? 0 : x % 2 == 1 ? p(x / 2) + 2 : p(- x - 1) + 1;
    }

    private static int q(int x) {
        return x % 3 == 0 ? 0 : q(x + x % 3 + 1) + 1;
    }

    // to be implemented by you
    public static void main(String[] args) {
        System.out.println("Ergebnisse für f:");
        // print results of all terminating invocations of f with arguments in the range [-10, 10]
        System.out.println("Ergebnisse für g:");
        // print results of all terminating invocations of g with arguments in the range [-10, 10]
        System.out.println("Ergebnisse für h:");
        // print results of all terminating invocations of h with arguments in the range [-10, 10]
        System.out.println("Ergebnisse für p:");
        // print results of all terminating invocations of p with arguments in the range [-10, 10]
        System.out.println("Ergebnisse für q:");
        // print results of all terminating invocations of q with arguments in the range [-10, 10]
    }
}
